//  
#include "stdafx.h"
int n;
/////////////////////////////////////////////////////
LPWSTR OpenNewFile( HWND hwnd, const LPWSTR wndTitle, LPWSTR InitialDir=NULL,LPWSTR filter=(LPWSTR)"All Files (*.*)\0*.*\0\0"  )
{
	DWORD MAX_FILE=512;
    TCHAR *file=new TCHAR[MAX_FILE];
    static TCHAR fileTitle[512];
    //static char filter[] = "All Files (*.*)\0*.*\0";
    OPENFILENAME ofn;

    lstrcpy( (LPWSTR)file, L"");
    lstrcpy( (LPWSTR)fileTitle, L"");

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hwnd;
#ifdef WIN32
    ofn.hInstance         = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
#else
    ofn.hInstance         = (HINSTANCE) GetWindowWord(hwnd, GWW_HINSTANCE);
#endif
    ofn.lpstrFilter       = (LPWSTR)filter;
    ofn.lpstrCustomFilter = (LPWSTR) NULL;
    ofn.nMaxCustFilter    = 0L;
    ofn.nFilterIndex      = 1L;
    ofn.lpstrFile         = (LPWSTR)file;
    ofn.nMaxFile          = MAX_FILE;
    ofn.lpstrFileTitle    = (LPWSTR)fileTitle;
    ofn.nMaxFileTitle     = sizeof(fileTitle);
    ofn.lpstrInitialDir   = (LPWSTR)InitialDir;
    ofn.lpstrTitle        = (LPWSTR)wndTitle;
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = (LPWSTR)"*";
    ofn.lCustData         = 0;

    ofn.Flags =  OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOCHANGEDIR ;

	

    if (GetOpenFileName(&ofn))
	{
		const int MAX=256;
		LPWSTR CurDir=new TCHAR[MAX];
		LPWSTR FirstChars=new TCHAR[MAX];
		GetCurrentDirectory(MAX,(LPWSTR)CurDir);
		DWORD len=wcslen(CurDir);
		for (unsigned int n=0; n<len;n++)
			FirstChars[n]=ofn.lpstrFile[n];
		FirstChars[len]=0;
		//strcat(CurDir,"\\");
	//	strcat(CurDir,ofn.lpstrFileTitle);
		_wcsupr(CurDir);
		_wcsupr(FirstChars);
		//if (_wcsicmp(FirstChars,CurDir)==0)
		//{
		//	delete []CurDir; delete []FirstChars;
		//	return (LPWSTR)&((ofn.lpstrFile)[len+1]);
		//}
		//else
		//{
			delete []CurDir; delete []FirstChars;
			return (LPWSTR)ofn.lpstrFile;
		//}
	}
    else
        return NULL;
}

/////////////////////////////////////////////////////
LPWSTR SaveNewFile( HWND hwnd, const LPWSTR wndTitle, LPWSTR InitialDir=NULL,LPWSTR filter=(LPWSTR)"All Files (*.*)\0*.*\0" )
{
    static char file[256];
    static char fileTitle[256];
   // static char filter[] = "All Files (*.*)\0*.*\0";
    OPENFILENAME ofn;

    lstrcpy( (LPWSTR)file, (LPWSTR)"");
    lstrcpy( (LPWSTR)fileTitle, (LPWSTR)"");

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hwnd;
#ifdef WIN32
    ofn.hInstance         = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
#else
    ofn.hInstance         = (HINSTANCE) GetWindowWord(hwnd, GWW_HINSTANCE);
#endif
    ofn.lpstrFilter       = (LPWSTR)filter;
    ofn.lpstrCustomFilter = (LPWSTR) NULL;
    ofn.nMaxCustFilter    = 0L;
    ofn.nFilterIndex      = 1L;
    ofn.lpstrFile         = (LPWSTR)file;
    ofn.nMaxFile          = sizeof(file);
    ofn.lpstrFileTitle    = (LPWSTR)fileTitle;
    ofn.nMaxFileTitle     = sizeof(fileTitle);
    ofn.lpstrInitialDir   = (LPWSTR)InitialDir;
    ofn.lpstrTitle        = (LPWSTR)wndTitle;
    ofn.nFileOffset       = 0;
    ofn.nFileExtension    = 0;
    ofn.lpstrDefExt       = (LPWSTR)"*";
    ofn.lCustData         = 0;

    ofn.Flags =  OFN_PATHMUSTEXIST |OFN_NOCHANGEDIR;

    if (GetSaveFileName(&ofn))
	{

        return (LPWSTR)ofn.lpstrFile;
	}
    else
	{
	
        return NULL;
	}
}