
enum{
	DO_NORMAL,
	DO_SHADOW,
	DO_MIRROR,
	DO_MIRRORSHADOW,
};
class CGeometry
{
	public:
	LPDIRECT3DVERTEXBUFFER9 g_pVB;
	LPDIRECT3DINDEXBUFFER9  g_pIB;
	LPD3DXMESH				mesh;
	LPD3DXMESH				BoxMesh;
	D3DXMATRIXA16 SetTetraMatrix();
	D3DXMATRIXA16 SetTeapotMatrix();
	LPDIRECT3DTEXTURE9  Tex;
	LPWSTR TextureFileName;

	void DrawObjects(LPDIRECT3DDEVICE9 pd3dDevice,UINT Mode=DO_NORMAL);
	void DrawShadow(LPDIRECT3DDEVICE9 pd3dDevice,UINT Mode=DO_SHADOW);
	void DrawReflection(LPDIRECT3DDEVICE9 pd3dDevice);
	HRESULT SetTexture(LPDIRECT3DDEVICE9 pd3dDevice,LPWSTR FileName);
	CGeometry();
	HRESULT Init(LPDIRECT3DDEVICE9 pd3dDevice);
	void Draw(LPDIRECT3DDEVICE9 pd3dDevice);
	void Release(); 
	HRESULT SetupLights(LPDIRECT3DDEVICE9 pd3dDevice);
	void DrawRoom(LPDIRECT3DDEVICE9 pd3dDevice);
};